package com.fp.persistence.pgeneral.gene;

import java.sql.Timestamp;
import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import com.fp.dto.hb.History;
import javax.persistence.Transient;
import java.sql.Date;

/**Clase que hace referencia a la Clave Primaria de TGENETELLERTRANSFERHEADER*/
@Embeddable
public class TgeneTellerTransferHeaderKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId,History{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="WORKINGDATE", nullable=false,updatable=false)

/**
* Fecha de trabajo en la cual se origina la transferencia
*/
private Date workingdate;

@Column(name="USERCODE", nullable=false,updatable=false)

/**
* Codigo de usuario que origina la transferencia
*/
private String usercode;

@Column(name="TRANSFERNUMBER", nullable=false,updatable=false)

/**
* Secuencia de transferencia para el usuaio fecha de trabajo
*/
private Integer transfernumber;

@Column(name="DATETO", nullable=false,updatable=false)

/**
* Fecha hasta la cual esta vigente el registro
*/
private Timestamp dateto;

/**Contructor por defecto*/
public TgeneTellerTransferHeaderKey(){}
/**Contructor de TgeneTellerTransferHeaderKey
@param pWorkingdate Fecha de trabajo en la cual se origina la transferencia
@param pUsercode Codigo de usuario que origina la transferencia
@param pTransfernumber Secuencia de transferencia para el usuaio fecha de trabajo
@param pDateto Fecha hasta la cual esta vigente el registro
*/
public TgeneTellerTransferHeaderKey(Date pWorkingdate,String pUsercode,Integer pTransfernumber,Timestamp pDateto){
 workingdate=pWorkingdate;
 usercode=pUsercode;
 transfernumber=pTransfernumber;
 dateto=pDateto;
}
/**Obtiene el valor de workingdate
@return valor de workingdate*/
public Date getWorkingdate(){
  return workingdate;
}
/**Fija el valor de workingdate
@param pWorkingdate nuevo Valor de workingdate*/
public void setWorkingdate(Date pWorkingdate){
  workingdate=pWorkingdate;
}

/**Obtiene el valor de usercode
@return valor de usercode*/
public String getUsercode(){
  return usercode;
}
/**Fija el valor de usercode
@param pUsercode nuevo Valor de usercode*/
public void setUsercode(String pUsercode){
  usercode=pUsercode;
}

/**Obtiene el valor de transfernumber
@return valor de transfernumber*/
public Integer getTransfernumber(){
  return transfernumber;
}
/**Fija el valor de transfernumber
@param pTransfernumber nuevo Valor de transfernumber*/
public void setTransfernumber(Integer pTransfernumber){
  transfernumber=pTransfernumber;
}

/**Obtiene el valor de dateto
@return valor de dateto*/
public Timestamp getDateto(){
  return dateto;
}
/**Fija el valor de dateto
@param pDateto nuevo Valor de dateto*/
public void setDateto(Timestamp pDateto){
  dateto=pDateto;
}

/**Implementación de la comparación de TgeneTellerTransferHeaderKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneTellerTransferHeaderKey))return false;
  TgeneTellerTransferHeaderKey that = (TgeneTellerTransferHeaderKey) o;
  if (this.getWorkingdate() == null || that.getWorkingdate() == null){
      return false;
  }
  if (! this.getWorkingdate().equals(that.getWorkingdate())){
    return false;
  }
  if (this.getUsercode() == null || that.getUsercode() == null){
      return false;
  }
  if (! this.getUsercode().equals(that.getUsercode())){
    return false;
  }
  if (this.getTransfernumber() == null || that.getTransfernumber() == null){
      return false;
  }
  if (! this.getTransfernumber().equals(that.getTransfernumber())){
    return false;
  }
  if (this.getDateto() == null || that.getDateto() == null){
      return false;
  }
  if (! this.getDateto().equals(that.getDateto())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneTellerTransferHeaderKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getWorkingdate() == null ? 0 : this.getWorkingdate().hashCode());
    result = result * 37 + (this.getUsercode() == null ? 0 : this.getUsercode().hashCode());
    result = result * 37 + (this.getTransfernumber() == null ? 0 : this.getTransfernumber().hashCode());
    result = result * 37 + (this.getDateto() == null ? 0 : this.getDateto().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
public Object getId() {
  return null;
}
}
